package ps3;

public interface StringGraph {
	// OVERVIEW: A StringGraph is a directed graph  where
    //	V is a set of Strings, and E is a set of edges.
    // 	Each edge is a pair (v1, v2), representing an edge
    //	from v1 to v2 in G.  A typical StringGraph is
    //    < {v1, v2, ..., vn} , 
	//      { { v_a1, v_b1 }, { v_a2, v_b2 } , ... } >

	public void addNode(String s) throws DuplicateException;
	// MODIFIES: this
	// EFFECTS: If s is the name of a node in this, throws
    //	  DuplicateException. Otherwise, adds
    //    s to the nodes in this, with no adjacent nodes:
    //        Gpost = < Vpre U { s }, Epre >

	public void addEdge(String s, String t) throws NoNodeException, DuplicateException;
	// MODIFIES: this
	// EFFECTS: If s and t are not nodes in
    //    this, throws NoNodeException.  If there is already an edge
    //    between s and t, throws DuplicateEdgeException.
    //    Otherwise, adds an edge between s and t to this:
    //       Gpost = < Vpre, Epre U  >

	public Set<String> getAdjacent(String s) throws NoNodeException;
	// EFFECTS: If s is not a node in this, throws NoNodeException.
    //    Otherwise, returns a set containing the nodes adjacent to s
    //    That is, returns the set of nodes 
    //       { e | <s, e> is in E }

	public String toString();
    // EFFECTS: Returns a human-readable string representation of this.
}