package ps3;

public class StringGraphC implements StringGraph {
	
	class NodeRecord {
		String key;
		Set<String> values;

		NodeRecord (String p_key) {
			key = p_key;
			values = new Set<String>();
		}
		
		public boolean matches(String p_key) {
			return key.equals(p_key);
		}
		
		public void addEdge(String p_edge) throws DuplicateException
		{
			if (values.contains(p_edge)) throw new DuplicateException("<" + key + ", " + p_edge + ">");
			values.add(p_edge);
		}
	}

	private Set<NodeRecord> rep;
	
	public StringGraphC() {
		rep = new Set<NodeRecord>();
	}
	
	private NodeRecord getNode(String s) throws NoNodeException {
		// EFFECTS: If s is a node in this returns the corresponding NodeRecord.  If not,
		//    throws NoNodeException.
		for (NodeRecord r : rep) {
			if (r.matches(s)) {
				return r;
			}
		}
		throw new NoNodeException(s);
	}

	public void addEdge(String s, String t) throws NoNodeException,
			DuplicateException {
		NodeRecord srec = getNode(s);
		getNode(t); // only to get exception if t doesn't exist
		srec.addEdge(t); // DuplicateException will be rethrown
	}

	public void addNode(String s) throws DuplicateException {
		try {
			getNode(s);
			throw new DuplicateException(s);
		} catch (NoNodeException e) {
			// No exception means its not a duplicate
			rep.add(new NodeRecord(s));
		}
	}

	public Set<String> getAdjacent(String s) throws NoNodeException {
		NodeRecord r = getNode(s);
		return new Set<String>(r.values); // Need to copy the values
	}

	public String toString() {
		String res = "<";
		boolean firstone = true;
		for (NodeRecord r : rep) {
			if (firstone) {
				firstone = false;
			} else {
				res += ", ";
			}
			res += r.key;		
		}
		res += "; ";
		firstone = true;
		for (NodeRecord r : rep) {
			for (String e : r.values) {
				if (firstone) {
					firstone = false;
				} else {
					res += ", ";
				}
				res += "<" + r.key + ", " + e + ">";
			}
		}
		
		res += ">";
		return res;
	}
}
